"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mwsBuild = mwsBuild;
exports.mwsDevServer = mwsDevServer;
exports.mwsDLL = mwsDLL;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _path = _interopRequireDefault(require("path"));

var _fs = _interopRequireDefault(require("fs"));

var _mwBuild = _interopRequireDefault(require("./mwBuild"));

var _mwBabelOptions = _interopRequireDefault(require("./mwBabelOptions"));

var _mwPostCSSOptions = _interopRequireDefault(require("./mwPostCSSOptions"));

var _mwTSOptions = _interopRequireDefault(require("./mwTSOptions"));

var _mwDevServer = _interopRequireDefault(require("./mwDevServer"));

var _mwMultiEntryHTML = _interopRequireDefault(require("./mwMultiEntryHTML"));

var _mwPlugins = _interopRequireDefault(require("./mwPlugins"));

var _mwRules = _interopRequireDefault(require("./mwRules"));

var _mwENV = _interopRequireDefault(require("./mwENV"));

var _mwDLL = _interopRequireDefault(require("./mwDLL"));

var _mwPWA = _interopRequireDefault(require("./mwPWA"));

/**************************************************
 * Created by nanyuantingfeng on 22/08/2017 21:57.
 **************************************************/
function noop() {
  return _noop.apply(this, arguments);
}

function _noop() {
  _noop = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee() {
    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));
  return _noop.apply(this, arguments);
}

function getCustomConfig(cwd, config) {
  var _paths, _paths2, _paths3;

  if ('function' === typeof config) {
    return config;
  }

  var paths = [];

  switch (process.env.NODE_ENV) {
    case 'production':
      (_paths = paths).push.apply(_paths, ['build', 'production', 'prod']);

      break;

    case 'development':
      (_paths2 = paths).push.apply(_paths2, ['development', 'develop', 'dev']);

      break;

    case 'beta':
      (_paths3 = paths).push.apply(_paths3, ['beta', 'build', 'production', 'prod', 'development', 'develop', 'dev']);

      break;

    default:
      paths.push(process.env.NODE_ENV);
      break;
  }

  paths.push('config');
  paths = paths.map(function (name) {
    return "webpack.".concat(name, ".js");
  });
  config && paths.unshift(config);
  var cc = noop;
  var i = -1;

  while (++i < paths.length) {
    var p = paths[i];

    var pp = _path.default.join(cwd, p);

    if (_fs.default.existsSync(pp)) {
      console.log(">>> ".concat(pp));
      cc = require(pp);
      break;
    }
  }

  return cc;
}

function mwsBuild(cwd, config) {
  var mwConfig = getCustomConfig(cwd, config);
  return [_mwENV.default, _mwBuild.default, _mwPWA.default, _mwMultiEntryHTML.default, _mwDLL.default, _mwPlugins.default, _mwRules.default, _mwBabelOptions.default, _mwPostCSSOptions.default, _mwTSOptions.default, mwConfig];
}

function mwsDevServer(cwd, config) {
  var mwConfig = getCustomConfig(cwd, config);
  return [_mwENV.default, _mwBuild.default, _mwPWA.default, _mwMultiEntryHTML.default, _mwDLL.default, _mwPlugins.default, _mwRules.default, _mwBabelOptions.default, _mwPostCSSOptions.default, _mwTSOptions.default, _mwDevServer.default, mwConfig];
}

function mwsDLL(cwd, config) {
  var mwConfig = getCustomConfig(cwd, config);
  return [_mwENV.default, _mwBuild.default, _mwDLL.default, _mwPlugins.default, _mwRules.default, _mwBabelOptions.default, _mwPostCSSOptions.default, _mwTSOptions.default, mwConfig];
}